from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFQuestionnaire.config import *
from Products.CMFQuestionnaire.Questionnaire import Questionnaire

from StringIO import StringIO

def install(self):
    out = StringIO()

    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    print >> out, _migrate_from_0_3_2(self)
    
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()


def _migrate_from_0_3_2(self):
    out = StringIO()
    
    questionnaires = self.portal_catalog(meta_type = 'Questionnaire')
    for q in questionnaires:
        questionnaire = q.getObject()
        if not hasattr(questionnaire, 'use_ticket'):
            print >> out, "Migrating %s" % questionnaire.Title()

            oldid = questionnaire.id
            newid = oldid # + '_migrated_032'
            new_questionnaire = Questionnaire(newid)

            new_questionnaire.setTitle(questionnaire.Title())
            #new_questionnaire.setDescription(questionnaire.Description())
        
            new_questionnaire.use_ticket = 1
            new_questionnaire.body = questionnaire.form.documentElement.toxml()
            new_questionnaire.tickets = questionnaire.tickets
            new_questionnaire.used_tickets = []
            
            answers = '<answers>'
            if questionnaire.__dict__.has_key('submitted'):
                for form in questionnaire.submitted:
                    answers += '<form id="%s">' % form[0]
                    new_questionnaire.used_tickets.append(form[0])
                    for question in form[1].getElementsByTagName('question'):
                        answer = question.getElementsByTagName('answer')
                        if answer:
                            answers += '<question id="%s">' % question.getAttribute('id')
                            answers += answer[0].firstChild.nodeValue
                            answers += '</question>'
                    for comment in questionnaire.comments.getElementsByTagName('comment'):
                        if comment.getAttribute('id') == form[0]:
                            answers += '<comment>%s</comment>' % comment.firstChild.nodeValue
                    answers += '</form>'
            answers += '</answers>'
            new_questionnaire.answers = answers
        
            folder = questionnaire.aq_parent
            folder.manage_delObjects(oldid)
            folder._setObject(newid, new_questionnaire)
        
    return out.getvalue()
